//xsetaseta@gmail.com
//14/03/2016
//___Arduino_1.0.5___________-
//Debian 7

#define NUMCHAR  8
#define NUMGRAF  32
//Debug para consola serie
#define DEBUG 0



#define DS1302_CE   6    // Arduino pin for the Chip Enable
#define DS1302_IO   7    // Arduino pin for the Data I/O
#define DS1302_SCLK 8    // Arduino pin for the Serial Clock

#include <DS1302.h>

// Init the DS1302
DS1302 rtc(DS1302_CE, DS1302_IO, DS1302_SCLK);

String MiHora;

#include <OneWire.h>
OneWire  ds(A5);  // on pin 5 (a 4.7K resistor is necessary)
int temperatura;


// MAX7219
const static byte segmentos[60]={B01111111,B01000001,B01111111,  // 0-9
                                 B00000100,B00000010,B01111111,
                                 B01110001,B01001001,B01000111,
                                 B01001001,B01001001,B01111111,
                                 B00001111,B00001000,B01111100,
                                 B01001111,B01001001,B00111001,
                                 B01111110,B01001001,B01111001,
                                 B01111001,B00000101,B00000011,
                                 B01111111,B01001001,B01111111,
                                 B00001111,B00001001,B01111111,
                                 B00000000,B00000000,B00000000, //espacio
                                 B00000111,B00000101,B00000111, //º
                                 B01111111,B01000001,B01000001,  //C
                                 B00001000,B00001000,B00001000  //-
                                                             }; 
                            
unsigned char midisplay[NUMCHAR];
int LEDCONTROL_SPI_MOSI;
int LEDCONTROL_SPI_CLK;
int LEDCONTROL_SPI_CS;

byte spidata[16];

unsigned char GrafBuff[NUMGRAF];
char buffer[40];

char f1,f2,f3;
int time,Segundos,Minutos,Horas,intensidad;

void setup() 
{ 
  
  rtc.halt(false);
  rtc.writeProtect(false);
  
 #if DEBUG  
  Serial.begin(9600);
 #endif
 
  //int dataPin, int clkPin, int csPin
   LedControl(12,11,10);  
   
   pinMode(2,INPUT);
   pinMode(3,INPUT);
   pinMode(4,INPUT);
   pinMode(5,INPUT);
   
   intensidad=0; 
   setIntensity(intensidad);
  
   Horas=Segundos=Minutos=0;
   f3=0;
   Demo();
   watchdogOn();
}

void loop()
{
int z;

  if(HIGH==digitalRead(2))
      { 
         Horas++; if(Horas>23) Horas=0;
         time=Minutos+Horas*100; DisplayN(time); delay(300);
      }
  if(HIGH==digitalRead(3))
      { 
        Minutos++; if(Minutos>59) Minutos=0;
        time=Minutos+Horas*100; DisplayN(time); delay(300);
      }
  if(HIGH==digitalRead(4))
    { 
      if(f3==0)
        { f3=1;  DisplayN(0);  Horas=Minutos=0; }
        else  
        {  f3=0;  DisplayN(1111); rtc.setTime(Horas, Minutos, 0); }
      delay(600);
    }
 
  if(f2==1 && f3==0)
      {   
        f2=0;        
        if(Segundos>12 && Segundos<19 || Segundos>30 && Segundos<39 || Segundos>50 && Segundos<58)
          {
            if(0>=getTemp())
                { 
                   #if DEBUG   
                     Serial.println("No existe_18b20");
                   #endif
                }
                 else
                {
                   temperatura/=10; temperatura*=100;
                   intTOstring(temperatura,4,0,1);                   
                   if(temperatura>=0)
                     {
                       midisplay[5]=buffer[2]-48;
                       midisplay[4]=buffer[1]-48;            
                       midisplay[6]=11;   
                       midisplay[7]=12;
                     }
                     else
                     {
                       midisplay[4]=13;  //-
                       midisplay[5]=buffer[1]-48;            
                       midisplay[6]=buffer[2]-48;   
                       midisplay[7]=11;
                     }
                   DisplayMI();       Refres();
                   #if DEBUG
                     Serial.println(buffer);
                   #endif
                }     
          }
          else
          {
             MiHora=rtc.getTimeStr();  MiHora.toCharArray(buffer, 9);
             #if DEBUG
               Serial.print(buffer); Serial.println("<---");
             #endif
             midisplay[7]=buffer[4]-48;
             midisplay[6]=buffer[3]-48;
             midisplay[5]=buffer[1]-48;
             midisplay[4]=buffer[0]-48;
             DisplayMI();
            if(f1==0)
                {
                 f1=1;
                 GrafBuff[7]=128; 
                }
              else
                {
                  f1=0;
                  GrafBuff[7]=0;
                }
            Refres();
          }                   
             
      }  
      
}


//________________________________________

void watchdogOn() 
{  
MCUSR = MCUSR & B11110111;
WDTCSR = WDTCSR | B00011000; 
//WDTCSR = B00000101; //0.5S
WDTCSR = B00000110; //1S
//WDTCSR = B00100001; //8S

// Activa the watchdog timer interupt.
WDTCSR = WDTCSR | B01000000;
MCUSR = MCUSR & B11110111;
}

ISR(WDT_vect)
{
   Segundos++;
   if(Segundos>59)Segundos=0;
   f2=1;
}

//________________________________________

void Demo()
{
 int z;
  ClsBuff();
  for(z=1;z<NUMGRAF;z++) GrafBuff[z]=170; 
  Refres();  delay(500);  
  for(z=1;z<NUMGRAF;z++) GrafBuff[z]=85;   
  Refres();  delay(500); 
}

void ClsBuff()
{
 int z;
  for(z=0;z<NUMGRAF;z++)  GrafBuff[z]=0; 
}

void Refres()
{
 int seg,z,zz;
   for(seg=7;seg>=0;seg--)
     {
       digitalWrite(LEDCONTROL_SPI_CS,LOW);
       for(z=3;z>=0;z--)
          {
           zz=z<<3; zz+=seg; 
           spiTransferNONE_CS(8-seg,GrafBuff[zz]);
          }
       digitalWrite(LEDCONTROL_SPI_CS,HIGH);
     }
}

//____MAX7219___________________

void spiTransfer(  byte opcode, byte data)
{
  digitalWrite(LEDCONTROL_SPI_CS,LOW);
  shiftOut(LEDCONTROL_SPI_MOSI,LEDCONTROL_SPI_CLK,MSBFIRST,opcode);
  shiftOut(LEDCONTROL_SPI_MOSI,LEDCONTROL_SPI_CLK,MSBFIRST,data);
  digitalWrite(LEDCONTROL_SPI_CS,HIGH);  
}


void spiTransferNONE_CS(  byte opcode, byte data)
{
  shiftOut(LEDCONTROL_SPI_MOSI,LEDCONTROL_SPI_CLK,MSBFIRST,opcode);
  shiftOut(LEDCONTROL_SPI_MOSI,LEDCONTROL_SPI_CLK,MSBFIRST,data); 
}

void spiTransferALL(  byte opcode, byte data)
{
  int z,zz;
  
  digitalWrite(LEDCONTROL_SPI_CS,LOW);
   for (z=0;z<4;z++)
    {      
      shiftOut(LEDCONTROL_SPI_MOSI,LEDCONTROL_SPI_CLK,MSBFIRST,opcode);
      shiftOut(LEDCONTROL_SPI_MOSI,LEDCONTROL_SPI_CLK,MSBFIRST,data);     
    } 
    digitalWrite(LEDCONTROL_SPI_CS,HIGH); 
}


//Intensidad de los digitos
void setIntensity( byte intensity) 
{
    if(intensity>=0 || intensity<16) spiTransferALL(10,intensity);    
}

//Inicializa el MAX7219
void LedControl(int dataPin, int clkPin, int csPin)
{
    LEDCONTROL_SPI_MOSI=dataPin;
    LEDCONTROL_SPI_CLK=clkPin;
    LEDCONTROL_SPI_CS=csPin;
    pinMode(LEDCONTROL_SPI_MOSI,OUTPUT);
    pinMode(LEDCONTROL_SPI_CLK,OUTPUT);    
    pinMode(LEDCONTROL_SPI_CS,OUTPUT);
    digitalWrite(LEDCONTROL_SPI_CS,HIGH);
         
    spiTransferALL(12,0);  //shudown
    spiTransferALL(12,1);  //shudown
   
    spiTransferALL( 11,0xFF); //scanlimit los 8 display
    spiTransferALL(9,0);  //decodemode  modo segmentos
    spiTransferALL(0x0F,1);  //test mode    
    delay(50);
    spiTransferALL(0x0F,0);  //test mode     
}


//Pasa los digitos al MAX7219

void DisplayP2()
{
  DisplayMI();  
  Refres();
}

void DisplayMI()
{
int z,c,direc;
     direc=0;
     for (z=7;z>=0;z--)
        {                  
          c=midisplay[z];  c*=3;
          GrafBuff[direc]=segmentos[c+2];direc++;
          GrafBuff[direc]=segmentos[c+1];direc++;
          GrafBuff[direc]=segmentos[c];direc++;
          GrafBuff[direc]=0;direc++;
        } 
   
}

//Borra los numeroCaracteres digitos
void DisplayClear()
{
 int z;
  for (z=0;z<NUMCHAR;z++) midisplay[z]=10;
  DisplayP2();
}


//Imprimir numero
void DisplayN(long  numero)
{
  unsigned char z;
  unsigned char c;
  //_______numeroCaracteres____"%08d"___
  //sprintf(buffer,"%08d",numero);
  intTOstring(numero,NUMCHAR,0,0);
  
  for (z=0;z<NUMCHAR;z++)
    {
      c=buffer[z];
      midisplay[z]=c-48;
    }
  #if DEBUG
  //  Serial.println(buffer);
  #endif
  DisplayP2();
}  


//___________SETA43__
// numero,digitos,decimales,signo
void intTOstring(long n,unsigned char dig,unsigned char dec,unsigned char sig)
{
  long z,x;
  int zz;
  char signo;

	zz=0;  z=1;
        for(;dig>1;dig--) z=z*10;
        if(sig)
          {
	    if(n<0)	{ signo='-'; n*=-1;}	else	{signo='+';}
	    buffer[zz]=signo;	zz++;
          }
	for(;z>0;z=z/10)
	{
		x=n/z;
		n=n-(z*x);
		buffer[zz]=x+'0';
		zz++;
	}
	buffer[zz]=0;	
	if(dec!=0)
	 {
		x=zz+1;
		for(;zz>=0;zz--)
		{
		  buffer[x]=buffer[zz];
		  x--;
		  if(0==dec) { buffer[x]='.'; x--;}	
		  dec--;
		}
	 }
}

//______________________________________________________
//ds18B20
int getTemp()
{
  byte data[12];
  byte addr[8];
  int z;
  long  temp;
  byte decimal;

  //Solo para un sensor
  ds.reset_search();
  ds.search(addr);
  if ( OneWire::crc8( addr, 7) != addr[7])  { return -1; }
  if ( addr[0] != 0x10 && addr[0] != 0x28)  { return -2; }

  ds.reset();  ds.select(addr);  ds.write(0x4E);         
  ds.write(0x4B);    
  ds.write(0x46);    
  ds.write(0x7F);    // 12-bit sampling resolution (default)

  ds.reset();  ds.select(addr);  ds.write(0x44,1); // start conversion, with parasite power on at the end
  delay(900);  
  //delay(750);  

  ds.reset();  ds.select(addr);  ds.write(0xBE); // Read Scratchpad
  for ( z = 0; z < 9; z++) data[z] = ds.read();
    
  z = (data[1] << 8) | data[0];
  temp=z;
  temp=(temp*625)/1000;
  temperatura=temp;
  return 1;
}

